import { CodeFix } from "typescript-plugin-util";
import { Action } from "typescript-plugins-text-based-user-interaction";
import * as ts_module from 'typescript/lib/tsserverlibrary';
export declare const PLUGIN_NAME = "typescript-plugin-function-signature-refactors";
export interface SignatureRefactorArgs {
    log: (msg: any) => void;
    info: ts_module.server.PluginCreateInfo;
}
export declare function getRefactors(options: SignatureRefactorArgs): SignatureRefactorsCodeFix[];
export interface SignatureRefactorsCodeFix extends CodeFix {
    getCompletionsAtPosition(fileName: string, position: number, options: ts_module.GetCompletionsAtPositionOptions | undefined): ts_module.CompletionEntry[];
    /** helper that implements a generic langauge service method getApplicableRefactors */
    getApplicableRefactors(info: ts_module.server.PluginCreateInfo, refactorName: string, refactorActionName: string, fileName: string, positionOrRange: number | ts.TextRange, userPreferences: ts_module.UserPreferences): {
        refactors: ts.ApplicableRefactorInfo[];
        selectedAction?: Action;
    };
}
