import * as ts from 'typescript';
import { CodeFixOptions } from 'typescript-plugin-util';
import { Action } from "typescript-plugins-text-based-user-interaction";
import * as ts_module from 'typescript/lib/tsserverlibrary';
import { SignatureRefactorArgs, SignatureRefactorsCodeFix } from '../../refactors';
/**
 * # Description
 *
 *  Allows users to change a signature parameter order. see README
 *
 * # TODO
 *  * refactor a implementation method wont change its interface signature - super
 *  * constructors not supported
 */
export declare class ReorderParamsCodeFixImpl implements SignatureRefactorsCodeFix {
    private options;
    private interactionTool;
    name: string;
    config: any;
    private selectedAction?;
    private targetNameAndReorder;
    private inputConsumer;
    constructor(options: SignatureRefactorArgs);
    description(arg: CodeFixOptions): string;
    predicate(arg: CodeFixOptions): boolean;
    getCompletionsAtPosition(fileName: string, position: number, options: ts.GetCompletionsAtPositionOptions): ts.CompletionEntry[];
    getApplicableRefactors(info: ts_module.server.PluginCreateInfo, refactorName: string, refactorActionName: string, fileName: string, positionOrRange: number | ts.TextRange, userPreferences: ts_module.UserPreferences): {
        refactors: ts.ApplicableRefactorInfo[];
        selectedAction?: Action;
    };
    private getTextUITool;
    private getTargetNode;
    private getTargetNameAndReorder;
    private printRefactorSuggestionMessage;
    private getTextUIToolConfig;
    private applyImpl;
    apply(arg: CodeFixOptions): void | ts.ApplicableRefactorInfo[];
    private getSimpleTargetNode;
}
